import { Action as HistoryAction } from 'history';
import { RouterLocation } from './location';
import { RouteArgs } from './matchPath';
export declare const LOCATION_CHANGED = "@@direct-react-router/LOCATION_CHANGED";
export declare type LOCATION_CHANGED = typeof LOCATION_CHANGED;
export declare const HISTORY_METHOD_CALLED = "@@direct-react-router/HISTORY_METHOD_CALLED";
export declare type HISTORY_METHOD_CALLED = typeof HISTORY_METHOD_CALLED;
export interface LocationChangedAction {
    type: LOCATION_CHANGED;
    location: RouterLocation;
    action: HistoryAction;
}
export interface HistoryMethodCalledAction {
    type: HISTORY_METHOD_CALLED;
    url: string | RouteArgs;
    replace: boolean;
}
export declare function changeLocation(location: RouterLocation, action?: HistoryAction): LocationChangedAction;
export declare function callHistoryMethod(url: string | RouteArgs, replace?: boolean): HistoryMethodCalledAction;
