import React from 'react';
import { HistoryMethodCalledAction } from '../actions';
import { RouterConfig } from '../location';
export interface RouterContextData {
    config?: RouterConfig;
    basename?: string;
}
export declare const RouterContext: React.Context<RouterContextData>;
export declare type BaseLinkOwnProps = {
    target?: string;
    className?: string;
    attrs?: {
        [key: string]: string | number;
    };
    dangerouslySetInnerHTML?: {
        __html: string;
    };
    onClick?: (event: React.MouseEvent<HTMLAnchorElement>) => void;
};
export interface BaseLinkDispatchProps {
    onNavigate: (url: string) => HistoryMethodCalledAction;
}
export declare const dispatchProps: BaseLinkDispatchProps;
export declare abstract class BaseLinkComponent<T> extends React.Component<T & BaseLinkOwnProps & BaseLinkDispatchProps> {
    static contextType: React.Context<RouterContextData>;
    context: React.ContextType<typeof RouterContext>;
    protected abstract getHref(): string;
    handleClick: (event: React.MouseEvent<HTMLAnchorElement, MouseEvent>) => void;
    getRenderHref(): string;
    render(): JSX.Element;
}
