"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_to_regexp_1 = __importDefault(require("path-to-regexp"));
const cache = {};
const cacheLimit = 10000;
let cacheCount = 0;
function compilePath(path) {
    if (cache[path])
        return cache[path];
    const generator = path_to_regexp_1.default.compile(path);
    if (cacheCount < cacheLimit) {
        cache[path] = generator;
        cacheCount++;
    }
    return generator;
}
/**
 * Public API for generating a URL pathname from a path and parameters.
 */
function generatePath(path = '/', params = {}) {
    return path === '/' ? path : compilePath(path)(params);
}
exports.generatePath = generatePath;
