export interface Options {
    path: string | string[];
    exact?: boolean;
    strict?: boolean;
    sensitive?: boolean;
}
export interface MatchedParams {
    [extraProps: string]: string;
}
export interface RouteParams {
    [extraProps: string]: string[] | string;
}
export interface QueryParams {
    [extraProps: string]: string | string[] | null | undefined;
}
export interface RouteArgs {
    routeKey: string;
    params?: RouteParams;
    query?: QueryParams;
    hash?: string;
}
export interface MatchedPath {
    path: string;
    url: string;
    isExact: boolean;
    params: MatchedParams;
}
/**
 * Public API for matching a URL pathname to a path.
 */
export declare function matchPath(pathname: string, options: Options): MatchedPath | null;
