"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const location_1 = require("./location");
const actions_1 = require("./actions");
exports.createRoutingMiddleware = (config, history) => {
    return (store) => {
        // todo: when to unsubscribe?
        history.listen((location, action) => {
            const parsed = location_1.parseLocation(config, location);
            store.dispatch(actions_1.changeLocation(parsed, action));
        });
        return (next) => {
            return (action) => {
                const result = next(action);
                if (action.type === actions_1.HISTORY_METHOD_CALLED) {
                    const { url, replace } = action;
                    const href = typeof url === 'string'
                        ? url
                        : location_1.generateUrl(config, url);
                    if (replace) {
                        history.replace(href);
                    }
                    else {
                        history.push(href);
                    }
                }
                return result;
            };
        };
    };
};
